#ifndef STRUCTURES_H_INCLUDED
#define STRUCTURES_H_INCLUDED

#define TAILLE_MAX_CARTE 256
#define TAILLE_NOMS 16

/* definition des structures ncessaires */

/* SOMMAIRE */
/* Type_terrain */
/* Case */
/* Attaque */
/* Classe */
/* Personnage */
/* Effet */
/* Competence */



typedef enum {faux, vrai} boolean;

typedef struct {
    char nom[TAILLE_NOMS];
    boolean franchissable;
    boolean franchissable_sorts;
    unsigned short int PD_requis;
}Type_terrain;


typedef struct Case{
    unsigned short int coord_x;
    unsigned short int coord_y;
    Type_terrain *terrain;
    boolean occupee;
} Case;

typedef Case carte[TAILLE_MAX_CARTE];

typedef struct {
    char nom[TAILLE_NOMS];
    unsigned short int degats_directs;
    unsigned short int degats_permanents;
    unsigned short int portee;
    Effet effets[];
} Attaque;


typedef struct {
    char nom[TAILLE_NOMS];
    Attaque* attaques;
    unsigned short int points_deplacement_max;
    unsigned short int PV_max;
    unsigned short int mana_max;
} Classe;

typedef struct {
    char nom[TAILLE_NOMS];
    Classe classe;
    unsigned short int points_deplacement;
    unsigned short int PV;
    unsigned short int mana;
    Case *position;
    Effet effets[];
} Personnage;

typedef struct {
    unsigned int nb_tours_restants;
    unsigned int valeur_degats_duree;
    unsigned int valeur_soin_duree;
    boolean paralysie;
} Effet;


typedef struct competence{
    unsigned short int id;
    char nom[TAILLE_NOMS];
    unsigned short int etage;
    struct competence *enfant_gauche;
    struct competence *enfant_droit;
    struct effet_competence *effet;
    boolean connu;
}Competence;

typedef struct effet_competence{
    unsigned short int id;
    char nom[TAILLE_NOMS];
    /* effets  dfinir */

}effet_competence;

#endif
